module sineTable16bit (CLK, sine_addr, sine_out);
   input CLK;
   wire  CLK;
   input [7:0] sine_addr;
   wire [7:0]  sine_addr;
   output [15:0] sine_out;
   reg [15:0]    sine_out;

   always @(posedge CLK) begin
      case(sin_addr)
        8'h00: sine_out = 16'h0000 ;
        8'h01: sine_out = 16'h0192 ;
        8'h02: sine_out = 16'h0323 ;
        8'h03: sine_out = 16'h04b5 ;
        8'h04: sine_out = 16'h0645 ;
        8'h05: sine_out = 16'h07d5 ;
        8'h06: sine_out = 16'h0963 ;
        8'h07: sine_out = 16'h0af0 ;
        8'h08: sine_out = 16'h0c7c ;
        8'h09: sine_out = 16'h0e05 ;
        8'h0a: sine_out = 16'h0f8c ;
        8'h0b: sine_out = 16'h1111 ;
        8'h0c: sine_out = 16'h1293 ;
        8'h0d: sine_out = 16'h1413 ;
        8'h0e: sine_out = 16'h158f ;
        8'h0f: sine_out = 16'h1708 ;
        8'h10: sine_out = 16'h187d ;
        8'h11: sine_out = 16'h19ef ;
        8'h12: sine_out = 16'h1b5c ;
        8'h13: sine_out = 16'h1cc5 ;
        8'h14: sine_out = 16'h1e2a ;
        8'h15: sine_out = 16'h1f8b ;
        8'h16: sine_out = 16'h20e6 ;
        8'h17: sine_out = 16'h223c ;
        8'h18: sine_out = 16'h238d ;
        8'h19: sine_out = 16'h24d9 ;
        8'h1a: sine_out = 16'h261f ;
        8'h1b: sine_out = 16'h275f ;
        8'h1c: sine_out = 16'h2899 ;
        8'h1d: sine_out = 16'h29cc ;
        8'h1e: sine_out = 16'h2afa ;
        8'h1f: sine_out = 16'h2c20 ;
        8'h20: sine_out = 16'h2d40 ;
        8'h21: sine_out = 16'h2e59 ;
        8'h22: sine_out = 16'h2f6b ;
        8'h23: sine_out = 16'h3075 ;
        8'h24: sine_out = 16'h3178 ;
        8'h25: sine_out = 16'h3273 ;
        8'h26: sine_out = 16'h3366 ;
        8'h27: sine_out = 16'h3452 ;
        8'h28: sine_out = 16'h3535 ;
        8'h29: sine_out = 16'h3611 ;
        8'h2a: sine_out = 16'h36e4 ;
        8'h2b: sine_out = 16'h37ae ;
        8'h2c: sine_out = 16'h3870 ;
        8'h2d: sine_out = 16'h3929 ;
        8'h2e: sine_out = 16'h39da ;
        8'h2f: sine_out = 16'h3a81 ;
        8'h30: sine_out = 16'h3b1f ;
        8'h31: sine_out = 16'h3bb5 ;
        8'h32: sine_out = 16'h3c41 ;
        8'h33: sine_out = 16'h3cc4 ;
        8'h34: sine_out = 16'h3d3d ;
        8'h35: sine_out = 16'h3dad ;
        8'h36: sine_out = 16'h3e14 ;
        8'h37: sine_out = 16'h3e70 ;
        8'h38: sine_out = 16'h3ec4 ;
        8'h39: sine_out = 16'h3f0d ;
        8'h3a: sine_out = 16'h3f4d ;
        8'h3b: sine_out = 16'h3f83 ;
        8'h3c: sine_out = 16'h3fb0 ;
        8'h3d: sine_out = 16'h3fd2 ;
        8'h3e: sine_out = 16'h3feb ;
        8'h3f: sine_out = 16'h3ffa ;
        8'h40: sine_out = 16'h3fff ;
        8'h41: sine_out = 16'h3ffa ;
        8'h42: sine_out = 16'h3feb ;
        8'h43: sine_out = 16'h3fd2 ;
        8'h44: sine_out = 16'h3fb0 ;
        8'h45: sine_out = 16'h3f83 ;
        8'h46: sine_out = 16'h3f4d ;
        8'h47: sine_out = 16'h3f0d ;
        8'h48: sine_out = 16'h3ec4 ;
        8'h49: sine_out = 16'h3e70 ;
        8'h4a: sine_out = 16'h3e14 ;
        8'h4b: sine_out = 16'h3dad ;
        8'h4c: sine_out = 16'h3d3d ;
        8'h4d: sine_out = 16'h3cc4 ;
        8'h4e: sine_out = 16'h3c41 ;
        8'h4f: sine_out = 16'h3bb5 ;
        8'h50: sine_out = 16'h3b1f ;
        8'h51: sine_out = 16'h3a81 ;
        8'h52: sine_out = 16'h39da ;
        8'h53: sine_out = 16'h3929 ;
        8'h54: sine_out = 16'h3870 ;
        8'h55: sine_out = 16'h37ae ;
        8'h56: sine_out = 16'h36e4 ;
        8'h57: sine_out = 16'h3611 ;
        8'h58: sine_out = 16'h3535 ;
        8'h59: sine_out = 16'h3452 ;
        8'h5a: sine_out = 16'h3366 ;
        8'h5b: sine_out = 16'h3273 ;
        8'h5c: sine_out = 16'h3178 ;
        8'h5d: sine_out = 16'h3075 ;
        8'h5e: sine_out = 16'h2f6b ;
        8'h5f: sine_out = 16'h2e59 ;
        8'h60: sine_out = 16'h2d40 ;
        8'h61: sine_out = 16'h2c20 ;
        8'h62: sine_out = 16'h2afa ;
        8'h63: sine_out = 16'h29cc ;
        8'h64: sine_out = 16'h2899 ;
        8'h65: sine_out = 16'h275f ;
        8'h66: sine_out = 16'h261f ;
        8'h67: sine_out = 16'h24d9 ;
        8'h68: sine_out = 16'h238d ;
        8'h69: sine_out = 16'h223c ;
        8'h6a: sine_out = 16'h20e6 ;
        8'h6b: sine_out = 16'h1f8b ;
        8'h6c: sine_out = 16'h1e2a ;
        8'h6d: sine_out = 16'h1cc5 ;
        8'h6e: sine_out = 16'h1b5c ;
        8'h6f: sine_out = 16'h19ef ;
        8'h70: sine_out = 16'h187d ;
        8'h71: sine_out = 16'h1708 ;
        8'h72: sine_out = 16'h158f ;
        8'h73: sine_out = 16'h1413 ;
        8'h74: sine_out = 16'h1293 ;
        8'h75: sine_out = 16'h1111 ;
        8'h76: sine_out = 16'h0f8c ;
        8'h77: sine_out = 16'h0e05 ;
        8'h78: sine_out = 16'h0c7c ;
        8'h79: sine_out = 16'h0af0 ;
        8'h7a: sine_out = 16'h0963 ;
        8'h7b: sine_out = 16'h07d5 ;
        8'h7c: sine_out = 16'h0645 ;
        8'h7d: sine_out = 16'h04b5 ;
        8'h7e: sine_out = 16'h0323 ;
        8'h7f: sine_out = 16'h0192 ;
        8'h80: sine_out = 16'h0000 ;
        8'h81: sine_out = 16'hfe6e ;
        8'h82: sine_out = 16'hfcdd ;
        8'h83: sine_out = 16'hfb4b ;
        8'h84: sine_out = 16'hf9bb ;
        8'h85: sine_out = 16'hf82b ;
        8'h86: sine_out = 16'hf69d ;
        8'h87: sine_out = 16'hf510 ;
        8'h88: sine_out = 16'hf384 ;
        8'h89: sine_out = 16'hf1fb ;
        8'h8a: sine_out = 16'hf074 ;
        8'h8b: sine_out = 16'heeef ;
        8'h8c: sine_out = 16'hed6d ;
        8'h8d: sine_out = 16'hebed ;
        8'h8e: sine_out = 16'hea71 ;
        8'h8f: sine_out = 16'he8f8 ;
        8'h90: sine_out = 16'he783 ;
        8'h91: sine_out = 16'he611 ;
        8'h92: sine_out = 16'he4a4 ;
        8'h93: sine_out = 16'he33b ;
        8'h94: sine_out = 16'he1d6 ;
        8'h95: sine_out = 16'he075 ;
        8'h96: sine_out = 16'hdf1a ;
        8'h97: sine_out = 16'hddc4 ;
        8'h98: sine_out = 16'hdc73 ;
        8'h99: sine_out = 16'hdb27 ;
        8'h9a: sine_out = 16'hd9e1 ;
        8'h9b: sine_out = 16'hd8a1 ;
        8'h9c: sine_out = 16'hd767 ;
        8'h9d: sine_out = 16'hd634 ;
        8'h9e: sine_out = 16'hd506 ;
        8'h9f: sine_out = 16'hd3e0 ;
        8'ha0: sine_out = 16'hd2c0 ;
        8'ha1: sine_out = 16'hd1a7 ;
        8'ha2: sine_out = 16'hd095 ;
        8'ha3: sine_out = 16'hcf8b ;
        8'ha4: sine_out = 16'hce88 ;
        8'ha5: sine_out = 16'hcd8d ;
        8'ha6: sine_out = 16'hcc9a ;
        8'ha7: sine_out = 16'hcbae ;
        8'ha8: sine_out = 16'hcacb ;
        8'ha9: sine_out = 16'hc9ef ;
        8'haa: sine_out = 16'hc91c ;
        8'hab: sine_out = 16'hc852 ;
        8'hac: sine_out = 16'hc790 ;
        8'had: sine_out = 16'hc6d7 ;
        8'hae: sine_out = 16'hc626 ;
        8'haf: sine_out = 16'hc57f ;
        8'hb0: sine_out = 16'hc4e1 ;
        8'hb1: sine_out = 16'hc44b ;
        8'hb2: sine_out = 16'hc3bf ;
        8'hb3: sine_out = 16'hc33c ;
        8'hb4: sine_out = 16'hc2c3 ;
        8'hb5: sine_out = 16'hc253 ;
        8'hb6: sine_out = 16'hc1ec ;
        8'hb7: sine_out = 16'hc190 ;
        8'hb8: sine_out = 16'hc13c ;
        8'hb9: sine_out = 16'hc0f3 ;
        8'hba: sine_out = 16'hc0b3 ;
        8'hbb: sine_out = 16'hc07d ;
        8'hbc: sine_out = 16'hc050 ;
        8'hbd: sine_out = 16'hc02e ;
        8'hbe: sine_out = 16'hc015 ;
        8'hbf: sine_out = 16'hc006 ;
        8'hc0: sine_out = 16'hc001 ;
        8'hc1: sine_out = 16'hc006 ;
        8'hc2: sine_out = 16'hc015 ;
        8'hc3: sine_out = 16'hc02e ;
        8'hc4: sine_out = 16'hc050 ;
        8'hc5: sine_out = 16'hc07d ;
        8'hc6: sine_out = 16'hc0b3 ;
        8'hc7: sine_out = 16'hc0f3 ;
        8'hc8: sine_out = 16'hc13c ;
        8'hc9: sine_out = 16'hc190 ;
        8'hca: sine_out = 16'hc1ec ;
        8'hcb: sine_out = 16'hc253 ;
        8'hcc: sine_out = 16'hc2c3 ;
        8'hcd: sine_out = 16'hc33c ;
        8'hce: sine_out = 16'hc3bf ;
        8'hcf: sine_out = 16'hc44b ;
        8'hd0: sine_out = 16'hc4e1 ;
        8'hd1: sine_out = 16'hc57f ;
        8'hd2: sine_out = 16'hc626 ;
        8'hd3: sine_out = 16'hc6d7 ;
        8'hd4: sine_out = 16'hc790 ;
        8'hd5: sine_out = 16'hc852 ;
        8'hd6: sine_out = 16'hc91c ;
        8'hd7: sine_out = 16'hc9ef ;
        8'hd8: sine_out = 16'hcacb ;
        8'hd9: sine_out = 16'hcbae ;
        8'hda: sine_out = 16'hcc9a ;
        8'hdb: sine_out = 16'hcd8d ;
        8'hdc: sine_out = 16'hce88 ;
        8'hdd: sine_out = 16'hcf8b ;
        8'hde: sine_out = 16'hd095 ;
        8'hdf: sine_out = 16'hd1a7 ;
        8'he0: sine_out = 16'hd2c0 ;
        8'he1: sine_out = 16'hd3e0 ;
        8'he2: sine_out = 16'hd506 ;
        8'he3: sine_out = 16'hd634 ;
        8'he4: sine_out = 16'hd767 ;
        8'he5: sine_out = 16'hd8a1 ;
        8'he6: sine_out = 16'hd9e1 ;
        8'he7: sine_out = 16'hdb27 ;
        8'he8: sine_out = 16'hdc73 ;
        8'he9: sine_out = 16'hddc4 ;
        8'hea: sine_out = 16'hdf1a ;
        8'heb: sine_out = 16'he075 ;
        8'hec: sine_out = 16'he1d6 ;
        8'hed: sine_out = 16'he33b ;
        8'hee: sine_out = 16'he4a4 ;
        8'hef: sine_out = 16'he611 ;
        8'hf0: sine_out = 16'he783 ;
        8'hf1: sine_out = 16'he8f8 ;
        8'hf2: sine_out = 16'hea71 ;
        8'hf3: sine_out = 16'hebed ;
        8'hf4: sine_out = 16'hed6d ;
        8'hf5: sine_out = 16'heeef ;
        8'hf6: sine_out = 16'hf074 ;
        8'hf7: sine_out = 16'hf1fb ;
        8'hf8: sine_out = 16'hf384 ;
        8'hf9: sine_out = 16'hf510 ;
        8'hfa: sine_out = 16'hf69d ;
        8'hfb: sine_out = 16'hf82b ;
        8'hfc: sine_out = 16'hf9bb ;
        8'hfd: sine_out = 16'hfb4b ;
        8'hfe: sine_out = 16'hfcdd ;
        8'hff: sine_out = 16'hfe6e ;
      endcase
   end
endmodule
